<template>
  <div class="container mt-5 mb-5">
    <div class="row">
      <div class="col-md-4">
        <div class="card border-0 rounded shadow">
          <div class="card-body p-2">
            <!-- product image -->
            <img :src="product.image" class="w-100 border">
          </div>
        </div>
      </div>
      <div class="col-md-8">
        <div class="card border-0 rounded shadow">
          <div class="card-body text-left">
            <!-- product title -->
           <div class="product-title">
            <label class="font-weight-bold text-left"> {{ product.title }} </label>
           </div>
            <hr>
            <!-- product price -->
            <div class="price-product" id="price-product">
              <span class="font-weight-bold mr-4">Rp {{ calculateDiscount(product) }}</span>
              <s class="font-weight-bold text-muted" style="text-decoration-color:red">Rp. {{ product.price }}</s>
            </div>
            <div class="table-responsive">
              <table class="table table-borderless mt-3">
                <tbody>
                  <!-- product discount -->
                  <tr>
                    <td class="font-weight-bold">Discount</td>
                    <td>:</td>
                    <td>
                      <button class="btn btn-sm" style="color: #ff2f00;border-color: #ff2f00;">
                        Discount {{ product.discount }} %
                      </button>
                    </td>
                  </tr>
                  <!-- product weight -->
                  <tr>
                    <td class="font-weight-bold">Weight</td>
                    <td>:</td>
                    <td>
                      <span class="badge badge-pill badge-success"
                        style="font-size: 14px;border-radius: .3rem;padding: .25em .5em .2em;">
                        {{ product.weight }} gr
                      </span>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
            <button @click="addToCart(product.id, calculateDiscount(product), product.weight)"
              class="btn btn-primary btn-md btn-block border-0"><i class="fa fa-shopping-cart mr-2"></i>
              Add to Cart
            </button>
          </div>
        </div>
      </div>
    </div>
    <!-- product description -->
    <div class="row mt-5">
      <div class="col-md-12">
        <div class="card border-0 rounded shadow">
          <div class="card-body text-left">
            <label class="font-weight-bold mb-2" style="font-size: 20px">Description</label>
            <div v-html="product.content"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
import { computed, onMounted } from 'vue'   // computed dan onMounted
import { useStore } from 'vuex' // store Vuex
import { useRoute, useRouter } from 'vue-router' // vue router

export default {
  name: 'ProductShowComponent',

  setup() {
    // vue route
    const route = useRoute()

    // vue router
    const router = useRouter()

    // store vuex
    const store = useStore()

    // onMounted akan menjalankan action "getDetailProduct" di module "product" Vuex
    onMounted(() => {
      store.dispatch('product/getDetailProduct', route.params.slug)
    });

    // computed properti digunakan untuk mendapatkan data detail product dari state "product" di module "product" Vuex 
    const product = computed(() => {
      return store.state.product.product
    });

    // function add to cart
    function addToCart(product_id, price, weight) {
      // check token first
      const token = store.state.auth.token

      if (!token) {
        return router.push({ name: 'login' })
      }

      // panggil action addToCart do module cart
      store.dispatch('cart/addToCart', {
        product_id: product_id,
        price: price,
        weight: weight,
        quantity: 1,
      });
    }

    // return
    return {
      route,
      router,
      store,
      product,
      addToCart
    }
  }
}
</script>
<style scoped>
@media screen and (min-width: 768px) {
  .price-product {
    font-size: 1.35rem;
    margin-left: 10px;
  }

  .product-title {
    font-size: 1.35rem;
  }
}


@media screen and (min-width: 0px) and (max-width: 765px) {
  .price-product {
    margin-left: 12px;
  }
}
</style>